SystemOrganization addCategory: #homeWork!
SystemOrganization addCategory: #'homeWork-tests'!
SystemOrganization addCategory: #'homeWork-version1'!

Object subclass: #HWRoassalDrawer
	instanceVariableNames: 'elements selected'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWRoassalDrawer commentStamp: 'test 12/21/2018 16:05' prior: 0!
Responsible for drawing a Roassal view in the HWMainPresenter

It knows the list of elements that the HWMainPresenter is showing, and the element in this list that is selected.
It is responsible to show this element in some way!

HWRoassalDrawer subclass: #HWDrawerSubclassesWithForceLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerSubclassesWithForceLayout methodsFor: 'drawing' stamp: 'test 12/21/2018 16:10'!
drawOnRoassalView: roassalView
	| es |
	roassalView @ RTDraggableView.
	es := (RTEllipse new
		size: 15;
		color: [ :c | 
			c = selected
				ifTrue: [ Color green ]
				ifFalse: [ Color black alpha: 0.5 ] ]) elementsOn: selected withAllSubclasses.
	roassalView addAll: es.
	es @ RTDraggable @ RTPopup.
	RTEdgeBuilder new
		view: roassalView;
		elements: es;
		connectFrom: #superclass.
	RTForceBasedLayout new on: es! !

HWRoassalDrawer subclass: #HWDrawerSuperclassesWithTreeLayout
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWDrawerSuperclassesWithTreeLayout methodsFor: 'drawing' stamp: 'test 12/21/2018 16:18'!
drawOnRoassalView: roassalView
	| es |
	roassalView @ RTDraggableView.
	es := (RTEllipse new
		size: 15;
		color: [ :c | 
			c = selected
				ifTrue: [ Color green ]
				ifFalse: [ Color black alpha: 0.5 ] ]) elementsOn: selected withAllSuperclasses.
	roassalView addAll: es.
	es @ RTDraggable @ RTPopup.
	RTEdgeBuilder new
		view: roassalView;
		elements: es;
		connectFrom: #superclass.
	RTTreeLayout new on: es! !

!HWRoassalDrawer methodsFor: 'drawing' stamp: 'test 12/21/2018 16:08'!
drawOnRoassalView: aView
	self subclassResponsibility! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
elements
	^ elements! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
elements: anObject
	elements := anObject! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
selected
	^ selected! !

!HWRoassalDrawer methodsFor: 'accessing' stamp: 'test 12/21/2018 16:05'!
selected: anObject
	selected := anObject! !

TestCase subclass: #WidgetClassListTest
	instanceVariableNames: ''
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-tests'!

!WidgetClassListTest methodsFor: 'as yet unclassified' stamp: 'allerSchema 12/19/2018 16:00'!
testFilter
	"Je permet de test filtre d'une liste "

	self assert: ((WidgetClassList new filter: OrderedCollection allSubclasses with: 'GL') at: 1) equals: GLMMultiValue! !

ComposablePresenter subclass: #ClassHierachyWidget
	instanceVariableNames: 'classes diagram selectedClass diagramView'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!ClassHierachyWidget commentStamp: 'Steflivre 12/20/2018 00:41' prior: 0!
Je permet de dessiner l'hierachy à laquelle une classe appartient !

!ClassHierachyWidget class methodsFor: 'as yet unclassified' stamp: 'test 12/21/2018 13:22'!
defaultRunSize
	<script>
	ClassHierachyWidget new
		listView: Collection  withAllSubclasses;
		"ClassHierachyWidget new
		diagramView: MyNewRoassalView new ;
		listView: Collection withAllSubClasses ;
		openWithSpec."
			openWithSpec! !

!ClassHierachyWidget class methodsFor: 'overrides' stamp: 'Steflivre 12/20/2018 00:09'!
defaultSpec
	^ SpecRowLayout composed
		add: #classes;
		add: #diagram;
		yourself! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 17:30'!
classes
^classes! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'Steflivre 12/20/2018 00:04'!
diagram
	^diagram ! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'Steflivre 12/20/2018 00:04'!
diagram: anObject
	diagram := anObject! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'test 12/21/2018 13:44'!
diagramView
	^ diagramView! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'test 12/21/2018 13:45'!
diagramView: aMyViewRoassal
	diagramView := aMyViewRoassal! !

!ClassHierachyWidget methodsFor: 'overrides' stamp: 'allerSchema 12/20/2018 15:36'!
initializePresenter
	self classes
		onClassSelected: [ :item | 
			selectedClass := item.
			diagram refresh.
			 ]! !

!ClassHierachyWidget methodsFor: 'overrides' stamp: 'test 12/21/2018 14:07'!
initializeWidgets
	classes := self instantiate: WidgetClassList.
	diagram := self instantiate: RoassalModel.
	selectedClass := #().

	"This is the code for the Roassal view.
	The block takes both a view and a canvas."
	diagram
		script: [ :view :canvas  | self diagramView viewScript value: view value: canvas value: selectedClass  ]! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'allezschema 12/20/2018 22:23'!
listView:aCollection
classes listClass: aCollection .! !

!ClassHierachyWidget methodsFor: 'accessing' stamp: 'allerSchema 12/20/2018 15:41'!
visualizationForView: view on: canvas
	| data shape elements |
	data := OrderedCollection new.
	selectedClass withAllSubAndSuperclassesDo: [ :cl | data add: cl ].
	shape := RTBox new color: [ :c | c = selectedClass ifTrue: [Color red] ifFalse: [Color blue trans]].
	elements := shape elementsOn: data.
	view addAll: elements.
	elements @ RTPopup.
	RTEdgeBuilder new
		view: view;
		objects: data;
		connectFrom: [ :cl | cl superclass ].
	RTTreeLayout on: elements.
	view @ RTDraggableView.
	canvas camera focusOnCenterScaled: 300! !

ComposablePresenter subclass: #HWMainPresenter
	instanceVariableNames: 'classes diagram roassalDrawer'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!HWMainPresenter commentStamp: 'test 12/21/2018 16:26' prior: 0!
REsponsible for opening a window with a list of elements on the left and a Roassal diagram on the right.
Selecting an elements in the list on the left will trigger a refresh of the roassal view on the right

[[[
			(HWMainPresenter withDrawer: HWDrawerSubclassesWithForceLayout) openWithSpec 
]]]!

!HWMainPresenter class methodsFor: 'specs' stamp: 'test 12/21/2018 15:07'!
defaultSpec
	^ SpecRowLayout composed
		add: #classes;
		add: #diagram;
		yourself! !

!HWMainPresenter class methodsFor: 'as yet unclassified' stamp: 'test 12/21/2018 16:27'!
withDrawer: aDrawerClass
	^self basicNew
		withDrawer: aDrawerClass new;
		initialize ;
		yourself! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'test 12/21/2018 15:05'!
classes
	^ classes! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'test 12/21/2018 15:05'!
diagram
	^ diagram! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'test 12/21/2018 16:13'!
initializePresenter
	self classes
		onClassSelected: [ :item | 
			roassalDrawer selected: item.
			diagram refresh ]! !

!HWMainPresenter methodsFor: 'initialization' stamp: 'test 12/21/2018 16:27'!
initializeWidgets
	classes := self instantiate: WidgetClassList.
	classes listClass: (Collection withAllSubclasses sorted: [ :a :b | a name < b name ]).
	diagram := self instantiate: RoassalModel.
	diagram script: [ :view :canvas | roassalDrawer drawOnRoassalView: view ]! !

!HWMainPresenter methodsFor: 'accessing' stamp: 'test 12/21/2018 16:25'!
withDrawer: aDrawerInstance
	roassalDrawer := aDrawerInstance ! !

ComposablePresenter subclass: #WidgetClassList
	instanceVariableNames: 'listClass filtre'
	classVariableNames: ''
	poolDictionaries: ''
	category: 'homeWork-version1'!

!WidgetClassList class methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 15:08'!
defaultSpec
	| filtreHeight |
	filtreHeight := StandardFonts defaultFont height + 15.
	^ SpecLayout composed
				
				add: #listClass origin: 0 @ 0.2 corner: 1 @ 1;
				add: #filtre
					origin: 0 @ 0
					corner: 1 @ 0
					offsetOrigin: 0 @ 0
					offsetCorner: 0 @ filtreHeight;
		yourself! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 15:52'!
filter: aCollection with: aText

	^aCollection
		select: [ :cl | 
			(cl name matchesRegex: aText , '.*')
				 ].
	! !

!WidgetClassList methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 12:25'!
filtre
	^ filtre! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:53'!
initializePresenter
	filtre
		whenTextChanged: [ :text | 
			text = ''
				ifFalse: [ listClass items: (self filter: self listClass listItems with: text , '.*') ]
				ifTrue: [ listClass items: (Object allSubclasses sort:[:a :b|a name<b name])] ]! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allezschema 12/20/2018 22:26'!
initializeWidgets
	listClass := self newList.
	filtre := self newTextInput.
	"listClass items: (Object allSubclasses sort: [ :a :b | a name < b name ])."
	filtre
		ghostText: 'Enter a class name';
		autoAccept: true;
		removeEntryCompletion.
	self focusOrder
		add: listClass;
		add: filtre! !

!WidgetClassList methodsFor: 'accessing' stamp: 'allerSchema 12/19/2018 11:17'!
listClass
^listClass.! !

!WidgetClassList methodsFor: 'api' stamp: 'allezschema 12/20/2018 22:21'!
listClass: aCollection
	listClass items: aCollection .! !

!WidgetClassList methodsFor: 'api' stamp: 'allerSchema 12/20/2018 15:32'!
onClassSelected: aBlock
	self listClass whenSelectedItemChanged: aBlock! !

!WidgetClassList methodsFor: 'overrides' stamp: 'allerSchema 12/19/2018 16:54'!
title
^'Listes des classes'! !
